<template>
  <v-app>
    <v-toolbar color="primary" dark app>
      <v-btn class="text-capitalize" flat to="/">
        <v-toolbar-title>Producerstore</v-toolbar-title>
      </v-btn>
      <v-spacer></v-spacer>

      <v-btn to="/bestellingen" flat v-if="customerLoggedIn()">Bestellingen</v-btn>
      <v-btn to="/admin" flat v-if="isAdmin">admin</v-btn>
      <v-btn flat @click="loginOrLogout">{{$store.state.user.name || "Login"}}</v-btn>
      <v-btn to="/winkelwagen" flat>
        <v-icon dark>shopping_cart</v-icon>
        {{$store.state.shoppingCart.products.length}}
      </v-btn>
      <v-dialog v-model="showLoginDialog" width="600">
        <login-dialog @onClose="showLoginDialog = false"/>
      </v-dialog>
    </v-toolbar>
    <v-content>
      <v-alert dismissible :value="errorMessage != undefined" type="error">{{errorMessage}}</v-alert>
      <router-view/>
    </v-content>
  </v-app>
</template>

<script>
import LoginDialog from "@/components/dialog/LoginDialog";

export default {
  name: "App",
  components: { LoginDialog },
  data() {
    return {
      showLoginDialog: false,
      isAdmin: false,
      errorMessage: undefined
    };
  },

  mounted() {
    const query = this.$route.query;

    if (query.reason === "unauthorized") {
      this.errorMessage = query.message;
    }
  },

  methods: {
    loginOrLogout() {
      if (this.$store.state.user.name) {
        // if a user is logged in
        if (confirm("Weet je zeker dat je wilt uitloggen?")) {
          this.$store.commit("resetUser");
        }
      } else {
        this.showLoginDialog = true;
      }
    },

    customerLoggedIn() {
      return this.$store.state.user.roles && this.$store.state.user.roles.includes('customer');
    }
  },

  computed: {
    user() {
      return this.$store.state.user;
    }
  },

  watch: {
    user(newUser, oldUser) {
      this.isAdmin = newUser.roles.includes("admin");
    }
  }
};
</script>
